﻿import flash.geom.Matrix;
import flash.filters.BlurFilter;

class MyCloud{
	var mc,mcSrc:MovieClip;
	var arUnit,arFilter,arParamGradationColors,arParamGradationAlphas,arParamGradationRatios:Array;
	var nTimerHide,nSegment,nSpanX,nStepGradation,nAlphaMax,nPositionX:Number;
	var oMatrix:Matrix;
	function MyCloud(mcSrcIn:MovieClip){
		this.mcSrc = mcSrcIn;
		this.mc = _root.createEmptyMovieClip('mcCloud',_root.getNextHighestDepth());
		var owner:Object = this;
		this.mc.onEnterFrame = function(){owner.McOnEnterFrame();}
		
		this.nSpanX = 64;
		this.nSegment = Math.floor(Stage.width / this.nSpanX) + 2;
		this.nStepGradation = 20;
		this.nAlphaMax = 60;
		
		this.arUnit = new Array();
		for(var i=0;i<this.nSegment;i++)this.arUnit.push(new MyCloudUnit(this.arUnit));
		
		this.arParamGradationColors = new Array(0xFFFFFF,0xFFFFFF);
		this.arParamGradationAlphas = new Array(0x00,0x00);
		this.arParamGradationRatios = new Array(0x00,0xFF);
		this.arFilter = new Array(new BlurFilter(10,10,1));
		this.oMatrix = new Matrix();
	}
	function McOnEnterFrame(){
		for(var i=this.arUnit.length - 1;i>0;i--)this.arUnit[i].Update();
		this.arUnit[0].y = this.mcSrc._y;
		this.nPositionX = this.mcSrc._x + this.mcSrc._width;
		this.mc.moveTo(this.nPositionX,this.arUnit[0].y);
		this.mc.clear();
		for(var i=0;i<this.arUnit.length - 1;i++){
			this.CalcGradation(i);
			this.DrawGradation(i);
		}
		this.mc.filters = this.arFilter;
	}
	function CalcGradation(i){
		this.arParamGradationAlphas[0] = i * this.nStepGradation;
		this.arParamGradationAlphas[1] = (i + 1) * this.nStepGradation;
		if(this.arParamGradationAlphas[0] > this.nAlphaMax)this.arParamGradationAlphas[0] = this.nAlphaMax;
		if(this.arParamGradationAlphas[1] > this.nAlphaMax)this.arParamGradationAlphas[1] = this.nAlphaMax;
		this.oMatrix.createGradientBox(this.nSpanX,0,0,this.nPositionX,this.arUnit[i].y);
		this.mc.beginGradientFill("linear", this.arParamGradationColors,this.arParamGradationAlphas,this.arParamGradationRatios,this.oMatrix);
	}
	function DrawGradation(i){
		this.mc.moveTo(this.nPositionX,this.arUnit[i].y);
		this.mc.lineTo(this.nPositionX,this.arUnit[i].y + this.mcSrc._height);
		this.nPositionX += this.nSpanX;
		this.mc.lineTo(this.nPositionX,this.arUnit[i + 1].y + this.mcSrc._height);
		this.mc.lineTo(this.nPositionX,this.arUnit[i + 1].y);
		this.mc.endFill();
	}
}